SystemOrganization addCategory: #'Xenon-Tests'!

Object subclass: #XeFunctionThatHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionThatHasManyReturnTypeScenario commentStamp: 'BernardoContreras 4/5/2012 15:20' prior: 0!
A function that has many return types


!

!XeFunctionThatHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
	<returnType: #void>
! !

Object subclass: #XeFunctionWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
! !

Object subclass: #XeFunctionWhenReturnTypeIsUnknownScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsUnknownScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #unknown>
! !

Object subclass: #XeFunctionWithDefaultReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithDefaultReturnTypeScenario commentStamp: 'BernardoContreras 4/5/2012 15:19' prior: 0!
A function with a default return type.
!

!XeFunctionWithDefaultReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
! !

Object subclass: #XeFunctionWithOneArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithOneArgumentScenario commentStamp: 'BernardoContreras 4/5/2012 15:24' prior: 0!
A function with one argument.
!

!XeFunctionWithOneArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/2/2012 01:57'!
foo: x
	<returnType: #int>
! !

Object subclass: #XeFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithTwoArgumentsScenario commentStamp: 'BernardoContreras 4/5/2012 15:25' prior: 0!
A function with two arguments.


!

!XeFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/3/2012 23:36'!
foo: x and: y
	<returnType: #int>
! !

TestCase subclass: #XeTranslateFunctionTest
	instanceVariableNames: 'cg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateFunctionTest commentStamp: 'BernardoContreras 4/5/2012 15:12' prior: 0!
To test the translation of functions
!

!XeTranslateFunctionTest methodsFor: 'running' stamp: 'BernardoContreras 4/3/2012 21:05'!
setUp
	cg := XeCodeGenerator new! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/5/2012 15:22'!
testTranslateFunctionWhenItHasManyReturnTypes
	cg addClass: XeFunctionThatHasManyReturnTypeScenario.
	self should: [cg codeString] raise: XeTooManyReturnTypesError
! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/5/2012 15:23'!
testTranslateFunctionWhenReturnTypeIsDefault
	| actual expected |
	cg addClass: XeFunctionWithDefaultReturnTypeScenario.
	actual := cg codeString.
	expected := 'sqInt foo(){
}'.
	self assert: expected equals: actual! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 21:43'!
testTranslateFunctionWhenReturnTypeIsInteger
	| actual expected |
	cg addClass: XeFunctionWhenReturnTypeIsIntegerScenario.
	actual := cg codeString.
	expected := 'int foo(){
}'.
	self assert: expected equals: actual! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 21:43'!
testTranslateFunctionWhenReturnTypeIsUnknown
	cg addClass: XeFunctionWhenReturnTypeIsUnknownScenario.
	self should: [ cg codeString ] raise: XeTypeNotFoundError! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 21:44'!
testTranslateFunctionWithOneArgument
	| actual expected |
	cg addClass: XeFunctionWithOneArgumentScenario.
	actual := cg codeString.
	expected := 'int foo(sqInt x){
}'.
	self assert: expected equals: actual! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 23:37'!
testTranslateFunctionWithTwoArguments
	| actual expected |
	cg addClass: XeFunctionWithTwoArgumentsScenario.
	actual := cg codeString.
	expected := 'int fooand(sqInt x, sqInt y){
}'.
	self assert: expected equals: actual! !
